/*global $, app, console, Handlebars, iScroll*/

var TodayView = function (store) {
  "use strict";
  var self = this;
  this.initialize = function () {
    // Define a div wrapper for the view. The div wrapper is used to attach events.
    this.el = $('<div/>');
  };
  
  this.render = function () {
    this.el.html(TodayView.template());
    this.getEventsForToday();
    return this;
  };
  
  this.getEventsForToday = function () {
//    store.getEventListForToday(function (storedEvents) {
//      if (storedEvents.length >= 1) {
//        console.log('mem');
//        self.populateTemplate(storedEvents);
//      } else {
//        console.log('site');
//        app.executeJsonCall('http://themountaingoat.co.za/webservices/listEventsToday.php', function (events) {
//          store.storeEventsListForToday(events);
//          self.populateTemplate(events);
//        });
//      }
//    });
    
    app.executeJsonCall('http://themountaingoat.co.za/webservices/listEventsToday.php', function (events) {
      self.populateTemplate(events);
    });
  };
  
  this.populateTemplate = function (events) {
    console.log(events);
    if (events.length >= 1) {
      $('#today-list').html(TodayView.liTemplate(events));
    } else {
      $('#today-list').html(TodayView.noItemTemplate({ entity: "events" }));
    }
    app.setupIScroll(self);
//    $('.scroll').pullToRefresh({
//      callback: function () {
//        alert("pull to refresh callback");
//        var deferred = $.Deferred();
//
//        setTimeout(function () {
//          // Clear the entire memory content and refresh data.
//          store.clearStore();
//          self.getEventsForToday();
//          deferred.resolve();
//        }, 2000);
//
//        return deferred.promise();
//      }
//    });
//    $('.scroll').pullToUpdate({
//      callback: function () {
//        var deferred = $.Deferred();
//
//        setTimeout(function () {
//          self.getMoreEventsForToday(5);
//          deferred.resolve();
//        }, 2000);
//
//        return deferred.promise();
//      }
//    });
  };
  
  // Add {noOfEvents} events to the end of the list
//  this.getMoreEventsForToday = function (noOfEvents) {
//    var itemCount = $('#today-list li').length;
//    
//    app.executeJsonCall('http://themountaingoat.co.za/webservices/listEventsToday.php?index=' + itemCount + '&numberOfEvents=' + noOfEvents, function (events) {
//      store.storeEventsListForToday(events);
//      $('#today-list li:last').append(TodayView.liTemplate(events));
//    });
//  };
  
  this.initialize();
};
 
TodayView.template = Handlebars.compile($("#today-tpl").html());
TodayView.liTemplate = Handlebars.compile($("#event-li-tpl").html());
TodayView.noItemTemplate = Handlebars.compile($("#no-item-black-tpl").html());