/*global $, app, console, iScroll, cordova, Handlebars, scanner*/

var PastWalletView = function (store, dateScreen) {
  "use strict";
  // Application Constructor
  this.initialize = function () {
    this.el = $('<div/>');
  };

  this.render = function () {
    this.el.html(PastWalletView.template(dateScreen));
    this.getTokens();
    return this;
  };

  this.getTokens = function () {
    var self = this;
    
//    app.executeJsonCall('http://themountaingoat.co.za/webservices/listPastTokens.php?id=' + sessionStorage.getItem('fb_id'), function (data) {
    app.executeJsonCall('http://themountaingoat.co.za/webservices/listAllTokens.php?id=' + window.localStorage.getItem('fb_id'), function (data) {
      console.log(data);
      $('#token-list').html(PastWalletView.liTemplate(data));
      app.setupIScroll(self);
    });
  };

  this.initialize();
};

PastWalletView.template = Handlebars.compile($("#past-wallet-tpl").html());
PastWalletView.liTemplate = Handlebars.compile($("#token-li-tpl").html());