/*global $, app, console, Handlebars, iScroll*/

var TheNextDayView = function (store) {
  "use strict";
  var self = this;
  this.initialize = function () {
    var self = this;
    // Define a div wrapper for the view. The div wrapper is used to attach events.
    this.el = $('<div/>');
    //this.el.on('load', '.scroll', this.getEventsForTheNextDay);
  };

  this.render = function () {
    this.el.html(TheNextDayView.template());
    this.getEventsForTheNextDay();
    return this;
  };

  this.getEventsForTheNextDay = function () {
//    store.getEventListForTheNextDay(function (storedEvents) {
//      if (storedEvents.length >= 1) {
//        console.log('mem');
//        self.populateTemplate(storedEvents);
//      } else {
//        console.log('site');
//        app.executeJsonCall('http://themountaingoat.co.za/webservices/listEventsTheNextDay.php', function (events) {
//          store.storeEventsListForTheNextDay(events);
//          self.populateTemplate(events);
//        });
//      }
//    });
    
    app.executeJsonCall('http://themountaingoat.co.za/webservices/listEventsTheNextDay.php', function (events) {
      self.populateTemplate(events);
    });
  };
  
  this.populateTemplate = function (data) {
    console.log(data);
    if (data.length >= 1) {
      $('#the-next-day-list').html(TheNextDayView.liTemplate(data));
    } else {
      $('#the-next-day-list').html(TheNextDayView.noItemTemplate({ entity: "events" }));
    }
    app.setupIScroll(self);
//    $('.scroll').pullToRefresh({
//      callback: function () {
//        var deferred = $.Deferred();
//
//        setTimeout(function () {
//          // Clear the entire memory content and refresh data.
//          store.clearStore();
//          self.getEventsForTheNextDay();
//          deferred.resolve();
//        }, 2000);
//
//        return deferred.promise();
//      }
//    });
//    $('.scroll').pullToUpdate({
//      callback: function () {
//        var deferred = $.Deferred();
//
//        setTimeout(function () {
//          self.getMoreEventsForTheNextDay(5);
//          deferred.resolve();
//        }, 2000);
//
//        return deferred.promise();
//      }
//    });
  };
  
  // Add {noOfEvents} events to the end of the list
//  this.getMoreEventsForTheNextDay = function (noOfEvents) {
//    var itemCount = $('#the-next-day-list li').length;
//    
//    app.executeJsonCall('http://themountaingoat.co.za/webservices/listEventsTheNextDay.php?index=' + itemCount + '&numberOfEvents=' + noOfEvents, function (events) {
//      store.storeEventsList(events);
//      $('#the-next-day-list li:last').append(TheNextDayView.liTemplate(events));
//    });
//  };
  
  this.initialize();
};
 
TheNextDayView.template = Handlebars.compile($("#the-next-day-tpl").html());
TheNextDayView.liTemplate = Handlebars.compile($("#event-li-tpl").html());
TheNextDayView.noItemTemplate = Handlebars.compile($("#no-item-black-tpl").html());