/*global $, app, console, Handlebars, iScroll*/

var TomorrowView = function (store) {
  "use strict";
  var self = this;
  this.initialize = function () {
    var self = this;
    // Define a div wrapper for the view. The div wrapper is used to attach events.
    this.el = $('<div/>');
    //this.el.on('load', '.scroll', this.getEventsForTomorrow);
  };

  this.render = function () {
    this.el.html(TomorrowView.template());
    this.getEventsForTomorrow();
    return this;
  };

  this.getEventsForTomorrow = function () {
//    store.getEventListForTomorrow(function (storedEvents) {
//      if (storedEvents.length >= 1) {
//        console.log('mem');
//        self.populateTemplate(storedEvents);
//      } else {
//        console.log('site');
//        app.executeJsonCall('http://themountaingoat.co.za/webservices/listEventsTomorrow.php', function (events) {
//          store.storeEventsListForTomorrow(events);
//          self.populateTemplate(events);
//        });
//      }
//    });
    
    app.executeJsonCall('http://themountaingoat.co.za/webservices/listEventsTomorrow.php', function (events) {
      self.populateTemplate(events);
    });
  };
  
  this.populateTemplate = function (data) {
    console.log(data);
    if (data.length >= 1) {
      $('#tomorrow-list').html(TomorrowView.liTemplate(data));
    } else {
      $('#tomorrow-list').html(TomorrowView.noItemTemplate({ entity: "events" }));
    }
    app.setupIScroll(self);
//    $('.scroll').pullToRefresh({
//      callback: function () {
//        var deferred = $.Deferred();
//
//        setTimeout(function () {
//          // Clear the entire memory content and refresh data.
//          store.clearStore();
//          self.getEventsForTomorrow();
//          deferred.resolve();
//        }, 2000);
//
//        return deferred.promise();
//      }
//    });
//    $('.scroll').pullToUpdate({
//      callback: function () {
//        var deferred = $.Deferred();
//
//        setTimeout(function () {
//          self.getMoreEventsForTomorrow(5);
//          deferred.resolve();
//        }, 2000);
//
//        return deferred.promise();
//      }
//    });
  };
  
  // Add {noOfEvents} events to the end of the list
//  this.getMoreEventsForTomorrow = function (noOfEvents) {
//    var itemCount = $('#tomorrow-list li').length;
//    
//    app.executeJsonCall('http://themountaingoat.co.za/webservices/listEventsTomorrow.php?index=' + itemCount + '&numberOfEvents=' + noOfEvents, function (events) {
//      store.storeEventsListForTomorrow(events);
//      $('#tomorrow-list li:last').append(TomorrowView.liTemplate(events));
//    });
//  };
  
  this.initialize();
};
 
TomorrowView.template = Handlebars.compile($("#tomorrow-tpl").html());
TomorrowView.liTemplate = Handlebars.compile($("#event-li-tpl").html());
TomorrowView.noItemTemplate = Handlebars.compile($("#no-item-black-tpl").html());